--- /dev/null
+++ net/minecraft/src/ContainerChest.java
@@ -1,0 +1,57 @@
+package net.minecraft.src;
+
+public class ContainerChest extends Container {
+	private IInventory field_20125_a;
+	private int field_27282_b;
+
+	public ContainerChest(IInventory var1, IInventory var2) {
+		this.field_20125_a = var2;
+		this.field_27282_b = var2.getSizeInventory() / 9;
+		int var3 = (this.field_27282_b - 4) * 18;
+
+		int var4;
+		int var5;
+		for(var4 = 0; var4 < this.field_27282_b; ++var4) {
+			for(var5 = 0; var5 < 9; ++var5) {
+				this.addSlot(new Slot(var2, var5 + var4 * 9, 8 + var5 * 18, 18 + var4 * 18));
+			}
+		}
+
+		for(var4 = 0; var4 < 3; ++var4) {
+			for(var5 = 0; var5 < 9; ++var5) {
+				this.addSlot(new Slot(var1, var5 + var4 * 9 + 9, 8 + var5 * 18, 103 + var4 * 18 + var3));
+			}
+		}
+
+		for(var4 = 0; var4 < 9; ++var4) {
+			this.addSlot(new Slot(var1, var4, 8 + var4 * 18, 161 + var3));
+		}
+
+	}
+
+	public boolean isUsableByPlayer(EntityPlayer var1) {
+		return this.field_20125_a.canInteractWith(var1);
+	}
+
+	public ItemStack getStackInSlot(int var1) {
+		ItemStack var2 = null;
+		Slot var3 = (Slot)this.slots.get(var1);
+		if(var3 != null && var3.getHasStack()) {
+			ItemStack var4 = var3.getStack();
+			var2 = var4.copy();
+			if(var1 < this.field_27282_b * 9) {
+				this.func_28125_a(var4, this.field_27282_b * 9, this.slots.size(), true);
+			} else {
+				this.func_28125_a(var4, 0, this.field_27282_b * 9, false);
+			}
+
+			if(var4.stackSize == 0) {
+				var3.putStack((ItemStack)null);
+			} else {
+				var3.onSlotChanged();
+			}
+		}
+
+		return var2;
+	}
+}
--- net/minecraft/src/Packet53BlockChange.java
+++ net/minecraft/src/Packet53BlockChange.java
@@ -23,7 +23,7 @@
 		this.metadata = var1.read();
 	}
 
-	public void writePacket(DataOutputStream var1) throws IOException {
+	public void writePacketData(DataOutputStream var1) throws IOException {
 		var1.writeInt(this.xPosition);
 		var1.write(this.yPosition);
 		var1.writeInt(this.zPosition);
--- net/minecraft/src/Packet51MapChunk.java
+++ net/minecraft/src/Packet51MapChunk.java
@@ -13,8 +13,8 @@
 	public int xSize;
 	public int ySize;
 	public int zSize;
-	public byte[] chunkData;
-	private int tempLength;
+	public byte[] chunk;
+	private int chunkSize;
 
 	public Packet51MapChunk() {
 		this.isChunkDataPacket = true;
@@ -27,32 +27,32 @@
 		this.xSize = var1.read() + 1;
 		this.ySize = var1.read() + 1;
 		this.zSize = var1.read() + 1;
-		int var2 = var1.readInt();
-		byte[] var3 = new byte[var2];
-		var1.readFully(var3);
-		this.chunkData = new byte[this.xSize * this.ySize * this.zSize * 5 / 2];
-		Inflater var4 = new Inflater();
-		var4.setInput(var3);
+		this.chunkSize = var1.readInt();
+		byte[] var2 = new byte[this.chunkSize];
+		var1.readFully(var2);
+		this.chunk = new byte[this.xSize * this.ySize * this.zSize * 5 / 2];
+		Inflater var3 = new Inflater();
+		var3.setInput(var2);
 
 		try {
-			var4.inflate(this.chunkData);
-		} catch (DataFormatException var9) {
+			var3.inflate(this.chunk);
+		} catch (DataFormatException var8) {
 			throw new IOException("Bad compressed data format");
 		} finally {
-			var4.end();
+			var3.end();
 		}
 
 	}
 
-	public void writePacket(DataOutputStream var1) throws IOException {
+	public void writePacketData(DataOutputStream var1) throws IOException {
 		var1.writeInt(this.xPosition);
 		var1.writeShort(this.yPosition);
 		var1.writeInt(this.zPosition);
 		var1.write(this.xSize - 1);
 		var1.write(this.ySize - 1);
 		var1.write(this.zSize - 1);
-		var1.writeInt(this.tempLength);
-		var1.write(this.chunkData, 0, this.tempLength);
+		var1.writeInt(this.chunkSize);
+		var1.write(this.chunk, 0, this.chunkSize);
 	}
 
 	public void processPacket(NetHandler var1) {
@@ -60,6 +60,6 @@
 	}
 
 	public int getPacketSize() {
-		return 17 + this.tempLength;
+		return 17 + this.chunkSize;
 	}
 }
--- net/minecraft/src/GuiGameOver.java
+++ net/minecraft/src/GuiGameOver.java
@@ -21,11 +21,15 @@
 		}
 
 		if(var1.id == 1) {
-			this.mc.respawn();
+			this.mc.thePlayer.respawnPlayer();
 			this.mc.displayGuiScreen((GuiScreen)null);
 		}
 
 		if(var1.id == 2) {
+			if (this.mc.isMultiplayerWorld()) {
+				((EntityClientPlayerMP)this.mc.thePlayer).sendQueue.disconnect();
+			}
+			
 			this.mc.changeWorld1((World)null);
 			this.mc.displayGuiScreen(new GuiMainMenu());
 		}
--- /dev/null
+++ net/minecraft/src/Packet8UpdateHealth.java
@@ -1,0 +1,25 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class Packet8UpdateHealth extends Packet {
+	public int healthMP;
+
+	public void readPacketData(DataInputStream var1) throws IOException {
+		this.healthMP = var1.readShort();
+	}
+
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		var1.writeShort(this.healthMP);
+	}
+
+	public void processPacket(NetHandler var1) {
+		var1.handleHealth(this);
+	}
+
+	public int getPacketSize() {
+		return 2;
+	}
+}
--- /dev/null
+++ net/minecraft/src/BlockMiningProgress.java
@@ -1,0 +1,49 @@
+package net.minecraft.src;
+
+public class BlockMiningProgress {
+	   private final int id;
+	   private final int x;
+	   private final int y;
+	   private final int z;
+	   private int progress;
+	   private int lastUpdateTick;
+
+	   public BlockMiningProgress(int entityId, int x, int y, int z) {
+	      this.id = entityId;
+	      this.x = x;
+	      this.y = y;
+	      this.z = z;
+	   }
+
+	   public int getX() {
+	      return this.x;
+	   }
+
+	   public int getY() {
+	      return this.y;
+	   }
+
+	   public int getZ() {
+	      return this.z;
+	   }
+
+	   public void setProgress(int progress) {
+	      if (progress > 10) {
+	         progress = 10;
+	      }
+
+	      this.progress = progress;
+	   }
+
+	   public int getProgress() {
+	      return this.progress;
+	   }
+
+	   public void setLastUpdateTick(int lastUpdateTick) {
+	      this.lastUpdateTick = lastUpdateTick;
+	   }
+
+	   public int getLastUpdateTick() {
+	      return this.lastUpdateTick;
+	   }
+	}
--- net/minecraft/src/ItemTool.java
+++ net/minecraft/src/ItemTool.java
@@ -30,12 +30,12 @@
 		return 1.0F;
 	}
 
-	public void hitEntity(ItemStack var1, EntityLiving var2) {
-		var1.damageItem(2);
+	public void hitEntity(ItemStack var1, EntityLiving var2, EntityLiving var3) {
+		var1.damageItem(2, var3);
 	}
 
-	public void onBlockDestroyed(ItemStack var1, int var2, int var3, int var4, int var5) {
-		var1.damageItem(1);
+	public void onBlockDestroyed(ItemStack var1, int var2, int var3, int var4, int var5, EntityLiving var6) {
+		var1.damageItem(1, var6);
 	}
 
 	public int getDamageVsEntity(Entity var1) {
--- net/minecraft/src/EntityLiving.java
+++ net/minecraft/src/EntityLiving.java
@@ -26,6 +26,7 @@
 	public float swingProgress;
 	public int health = 10;
 	public int prevHealth;
+	public int somethingHealth = 0;
 	private int livingSoundTime;
 	public int hurtTime;
 	public int maxHurtTime;
@@ -67,6 +68,9 @@
 		this.unusedFloat = 1.0F;
 		this.stepHeight = 0.5F;
 	}
+	
+	protected void entityInit() {
+	}
 
 	protected boolean canEntityBeSeen(Entity var1) {
 		return this.worldObj.rayTraceBlocks(Vec3D.createVector(this.posX, this.posY + (double)this.getEyeHeight(), this.posZ), Vec3D.createVector(var1.posX, var1.posY + (double)var1.getEyeHeight(), var1.posZ)) == null;
@@ -98,7 +102,7 @@
 		if(this.rand.nextInt(1000) < this.livingSoundTime++) {
 			this.livingSoundTime = -this.getTalkInterval();
 			String var1 = this.getLivingSound();
-			if(var1 != null) {
+			if(var1 != null && !this.worldObj.multiplayerWorld) {
 				this.worldObj.playSoundAtEntity(this, var1, this.getSoundVolume(), (this.rand.nextFloat() - this.rand.nextFloat()) * 0.2F + 1.0F);
 			}
 		}
@@ -295,7 +299,7 @@
 
 	public boolean attackEntityFrom(Entity var1, int var2) {
 		if(this.worldObj.multiplayerWorld) {
-			var2 = 0;
+			return false;
 		}
 
 		this.entityAge = 0;
@@ -303,44 +307,62 @@
 			return false;
 		} else {
 			this.limbYaw = 1.5F;
+			boolean bool = true;
 			if((float)this.heartsLife > (float)this.heartsHalvesLife / 2.0F) {
-				if(this.prevHealth - var2 >= this.health) {
+				if(var2 <= this.somethingHealth) {
 					return false;
 				}
 
-				this.health = this.prevHealth - var2;
+				this.damageEntity(var2 - this.somethingHealth);
+				this.somethingHealth = var2;
+				bool = false;
 			} else {
+				this.somethingHealth = var2;
 				this.prevHealth = this.health;
 				this.heartsLife = this.heartsHalvesLife;
-				this.health -= var2;
+				this.damageEntity(var2);
 				this.hurtTime = this.maxHurtTime = 10;
 			}
 
 			this.attackedAtYaw = 0.0F;
-			if(var1 != null) {
-				double var3 = var1.posX - this.posX;
-
-				double var5;
-				for(var5 = var1.posZ - this.posZ; var3 * var3 + var5 * var5 < 1.0E-4D; var5 = (Math.random() - Math.random()) * 0.01D) {
-					var3 = (Math.random() - Math.random()) * 0.01D;
+			if(bool) {
+				if(var1 != null) {
+					double var3 = var1.posX - this.posX;
+
+					double var5;
+					for(var5 = var1.posZ - this.posZ; var3 * var3 + var5 * var5 < 1.0E-4D; var5 = (Math.random() - Math.random()) * 0.01D) {
+						var3 = (Math.random() - Math.random()) * 0.01D;
+					}
+
+					this.attackedAtYaw = (float)(Math.atan2(var5, var3) * 180.0D / (double)((float)Math.PI)) - this.rotationYaw;
+					this.knockBack(var1, var2, var3, var5);
+				} else {
+					this.attackedAtYaw = (float)((int)(Math.random() * 2.0D) * 180);
 				}
-
-				this.attackedAtYaw = (float)(Math.atan2(var5, var3) * 180.0D / (double)((float)Math.PI)) - this.rotationYaw;
-				this.knockBack(var1, var2, var3, var5);
-			} else {
-				this.attackedAtYaw = (float)((int)(Math.random() * 2.0D) * 180);
 			}
+			
 
 			if(this.health <= 0) {
-				this.worldObj.playSoundAtEntity(this, this.getDeathSound(), this.getSoundVolume(), (this.rand.nextFloat() - this.rand.nextFloat()) * 0.2F + 1.0F);
+				if (bool && !this.worldObj.multiplayerWorld)
+					this.worldObj.playSoundAtEntity(this, this.getDeathSound(), this.getSoundVolume(), (this.rand.nextFloat() - this.rand.nextFloat()) * 0.2F + 1.0F);
+
 				this.onDeath(var1);
-			} else {
+			} else if (bool && !this.worldObj.multiplayerWorld) {
 				this.worldObj.playSoundAtEntity(this, this.getHurtSound(), this.getSoundVolume(), (this.rand.nextFloat() - this.rand.nextFloat()) * 0.2F + 1.0F);
 			}
 
 			return true;
 		}
 	}
+	
+	public void performHurtAnimation() {
+		this.hurtTime = this.maxHurtTime = 10;
+		this.attackedAtYaw = 0.0F;
+	}
+
+	protected void damageEntity(int var1) {
+		this.health -= var1;
+	}
 
 	protected float getSoundVolume() {
 		return 1.0F;
@@ -379,12 +401,14 @@
 		}
 
 		this.dead = true;
-		int var2 = this.getDropItemId();
-		if(var2 > 0) {
-			int var3 = this.rand.nextInt(3);
+		if(!this.worldObj.multiplayerWorld) {
+			int var2 = this.getDropItemId();
+			if(var2 > 0) {
+				int var3 = this.rand.nextInt(3);
 
-			for(int var4 = 0; var4 < var3; ++var4) {
-				this.dropItem(var2, 1);
+				for(int var4 = 0; var4 < var3; ++var4) {
+					this.dropItem(var2, 1);
+				}
 			}
 		}
 
@@ -399,7 +423,7 @@
 		if(var2 > 0) {
 			this.attackEntityFrom((Entity)null, var2);
 			int var3 = this.worldObj.getBlockId(MathHelper.floor_double(this.posX), MathHelper.floor_double(this.posY - (double)0.2F - (double)this.yOffset), MathHelper.floor_double(this.posZ));
-			if(var3 > 0) {
+			if(var3 > 0 && !this.worldObj.multiplayerWorld) {
 				StepSound var4 = Block.blocksList[var3].stepSound;
 				this.worldObj.playSoundAtEntity(this, var4.getStepSound(), var4.getVolume() * 0.5F, var4.getPitch() * (12.0F / 16.0F));
 			}
@@ -725,5 +749,25 @@
 		Vec3D var5 = this.getLook(var3);
 		Vec3D var6 = var4.addVector(var5.xCoord * var1, var5.yCoord * var1, var5.zCoord * var1);
 		return this.worldObj.rayTraceBlocks(var4, var6);
+	}
+	
+	public void handleHealthUpdate(byte var1) {
+		if(var1 == 2) {
+			this.limbYaw = 1.5F;
+			this.heartsLife = this.heartsHalvesLife;
+			this.hurtTime = this.maxHurtTime = 10;
+			this.attackedAtYaw = 0.0F;
+			if (!this.worldObj.multiplayerWorld)
+				this.worldObj.playSoundAtEntity(this, this.getHurtSound(), this.getSoundVolume(), (this.rand.nextFloat() - this.rand.nextFloat()) * 0.2F + 1.0F);
+			this.attackEntityFrom((Entity)null, 0);
+		} else if(var1 == 3) {
+			if (!this.worldObj.multiplayerWorld)
+				this.worldObj.playSoundAtEntity(this, this.getDeathSound(), this.getSoundVolume(), (this.rand.nextFloat() - this.rand.nextFloat()) * 0.2F + 1.0F);
+			this.health = 0;
+			this.onDeath((Entity)null);
+		} else {
+			super.handleHealthUpdate(var1);
+		}
+
 	}
 }
--- net/minecraft/src/ItemMinecart.java
+++ net/minecraft/src/ItemMinecart.java
@@ -12,7 +12,9 @@
 	public boolean onItemUse(ItemStack var1, EntityPlayer var2, World var3, int var4, int var5, int var6, int var7) {
 		int var8 = var3.getBlockId(var4, var5, var6);
 		if(var8 == Block.minecartTrack.blockID) {
-			var3.spawnEntityInWorld(new EntityMinecart(var3, (double)((float)var4 + 0.5F), (double)((float)var5 + 0.5F), (double)((float)var6 + 0.5F), this.minecartType));
+			if(!var3.multiplayerWorld) {
+				var3.spawnEntityInWorld(new EntityMinecart(var3, (double)((float)var4 + 0.5F), (double)((float)var5 + 0.5F), (double)((float)var6 + 0.5F), this.minecartType));
+			}
 			--var1.stackSize;
 			return true;
 		} else {
--- net/minecraft/src/NetworkReaderThread.java
+++ net/minecraft/src/NetworkReaderThread.java
@@ -15,24 +15,29 @@
 		}
 
 		while(true) {
-			boolean var11 = false;
+			boolean var12 = false;
 
 			try {
-				var11 = true;
-				if(NetworkManager.isRunning(this.netManager)) {
-					if(!NetworkManager.isServerTerminating(this.netManager)) {
-						NetworkManager.readNetworkPacket(this.netManager);
-						continue;
-					}
-
-					var11 = false;
-					break;
-				}
-
-				var11 = false;
-				break;
+				var12 = true;
+				if(!NetworkManager.isRunning(this.netManager)) {
+					var12 = false;
+					break;
+				}
+
+				if(NetworkManager.isServerTerminating(this.netManager)) {
+					var12 = false;
+					break;
+				}
+
+				while(NetworkManager.readNetworkPacket(this.netManager)) {
+				}
+
+				try {
+					sleep(2L);
+				} catch (InterruptedException var15) {
+				}
 			} finally {
-				if(var11) {
+				if(var12) {
 					Object var5 = NetworkManager.threadSyncObject;
 					synchronized(var5) {
 						--NetworkManager.numReadThreads;
--- net/minecraft/src/EnumArt.java
+++ net/minecraft/src/EnumArt.java
@@ -26,6 +26,7 @@
 	Skeleton("Skeleton", 64, 48, 192, 64),
 	DonkeyKong("DonkeyKong", 64, 48, 192, 112);
 
+	public static final int maxArtTitleLength = "SkullAndRoses".length();
 	public final String title;
 	public final int sizeX;
 	public final int sizeY;
--- /dev/null
+++ net/minecraft/src/Packet7UseEntity.java
@@ -1,0 +1,40 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class Packet7UseEntity extends Packet {
+	public int playerEntityId;
+	public int targetEntity;
+	public int isLeftClick;
+
+	public Packet7UseEntity() {
+	}
+
+	public Packet7UseEntity(int var1, int var2, int var3) {
+		this.playerEntityId = var1;
+		this.targetEntity = var2;
+		this.isLeftClick = var3;
+	}
+
+	public void readPacketData(DataInputStream var1) throws IOException {
+		this.playerEntityId = var1.readInt();
+		this.targetEntity = var1.readInt();
+		this.isLeftClick = var1.readByte();
+	}
+
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		var1.writeInt(this.playerEntityId);
+		var1.writeInt(this.targetEntity);
+		var1.writeByte(this.isLeftClick);
+	}
+
+	public void processPacket(NetHandler var1) {
+		var1.handleUseEntity(this);
+	}
+
+	public int getPacketSize() {
+		return 9;
+	}
+}
--- net/minecraft/src/RenderPig.java
+++ net/minecraft/src/RenderPig.java
@@ -8,7 +8,7 @@
 
 	protected boolean renderSaddledPig(EntityPig var1, int var2) {
 		this.loadTexture("/mob/saddle.png");
-		return var2 == 0 && var1.saddled;
+		return var2 == 0 && var1.getSaddled();
 	}
 
 	protected boolean shouldRenderPass(EntityLiving var1, int var2) {
--- /dev/null
+++ net/minecraft/src/Packet38EntityStatus.java
@@ -1,0 +1,28 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class Packet38EntityStatus extends Packet {
+	public int entityId;
+	public byte entityStatus;
+
+	public void readPacketData(DataInputStream var1) throws IOException {
+		this.entityId = var1.readInt();
+		this.entityStatus = var1.readByte();
+	}
+
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		var1.writeInt(this.entityId);
+		var1.writeByte(this.entityStatus);
+	}
+
+	public void processPacket(NetHandler var1) {
+		var1.func_9447_a(this);
+	}
+
+	public int getPacketSize() {
+		return 5;
+	}
+}
--- net/minecraft/src/Packet24MobSpawn.java
+++ net/minecraft/src/Packet24MobSpawn.java
@@ -3,6 +3,7 @@
 import java.io.DataInputStream;
 import java.io.DataOutputStream;
 import java.io.IOException;
+import java.util.List;
 
 public class Packet24MobSpawn extends Packet {
 	public int entityId;
@@ -12,6 +13,8 @@
 	public int zPosition;
 	public byte yaw;
 	public byte pitch;
+	private DataWatcher metaData;
+	private List receivedMetadata;
 
 	public Packet24MobSpawn() {
 	}
@@ -24,6 +27,7 @@
 		this.zPosition = MathHelper.floor_double(var1.posZ * 32.0D);
 		this.yaw = (byte)((int)(var1.rotationYaw * 256.0F / 360.0F));
 		this.pitch = (byte)((int)(var1.rotationPitch * 256.0F / 360.0F));
+		this.metaData = var1.getDataWatcher();
 	}
 
 	public void readPacketData(DataInputStream var1) throws IOException {
@@ -34,9 +38,10 @@
 		this.zPosition = var1.readInt();
 		this.yaw = var1.readByte();
 		this.pitch = var1.readByte();
+		this.receivedMetadata = DataWatcher.readWatchableObjects(var1);
 	}
 
-	public void writePacket(DataOutputStream var1) throws IOException {
+	public void writePacketData(DataOutputStream var1) throws IOException {
 		var1.writeInt(this.entityId);
 		var1.writeByte(this.type);
 		var1.writeInt(this.xPosition);
@@ -44,6 +49,7 @@
 		var1.writeInt(this.zPosition);
 		var1.writeByte(this.yaw);
 		var1.writeByte(this.pitch);
+		this.metaData.writeWatchableObjects(var1);
 	}
 
 	public void processPacket(NetHandler var1) {
@@ -51,6 +57,10 @@
 	}
 
 	public int getPacketSize() {
-		return 19;
+		return 20;
+	}
+
+	public List getMetadata() {
+		return this.receivedMetadata;
 	}
 }
--- net/minecraft/src/RenderItem.java
+++ net/minecraft/src/RenderItem.java
@@ -56,7 +56,7 @@
 					GL11.glTranslatef(var16, var17, var18);
 				}
 
-				this.itemRenderBlocks.renderBlockOnInventory(Block.blocksList[var10.itemID]);
+				this.itemRenderBlocks.renderBlockOnInventory(Block.blocksList[var10.itemID], var10.getItemDamageForDisplay());
 				GL11.glPopMatrix();
 			}
 		} else {
@@ -116,7 +116,7 @@
 				GL11.glRotatef(45.0F, 0.0F, 1.0F, 0.0F);
 				GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
 				GL11.glScalef(1.0F, 1.0F, 1.0F);
-				this.itemRenderBlocks.renderBlockOnInventory(var7);
+				this.itemRenderBlocks.renderBlockOnInventory(var7, var3.getItemDamageForDisplay());
 				GL11.glPopMatrix();
 			} else if(var3.getIconIndex() >= 0) {
 				GL11.glDisable(GL11.GL_LIGHTING);
@@ -145,9 +145,9 @@
 				GL11.glEnable(GL11.GL_DEPTH_TEST);
 			}
 
-			if(var3.itemDmg > 0) {
-				int var11 = 13 - var3.itemDmg * 13 / var3.getMaxDamage();
-				int var7 = 255 - var3.itemDmg * 255 / var3.getMaxDamage();
+			if(var3.getItemDamage() > 0 && var3.isItemStackDamageable()) {
+				int var11 = 13 - var3.getItemDamage() * 13 / var3.getMaxDamage();
+				int var7 = 255 - var3.getItemDamage() * 255 / var3.getMaxDamage();
 				GL11.glDisable(GL11.GL_LIGHTING);
 				GL11.glDisable(GL11.GL_DEPTH_TEST);
 				GL11.glDisable(GL11.GL_TEXTURE_2D);
--- net/minecraft/src/EntityMinecart.java
+++ net/minecraft/src/EntityMinecart.java
@@ -19,6 +19,9 @@
 	private double minecartZ;
 	private double minecartYaw;
 	private double minecartPitch;
+	private double lerpVelocityX;
+	private double lerpVelocityY;
+	private double lerpVelocityZ;
 
 	public EntityMinecart(World var1) {
 		super(var1);
@@ -33,6 +36,9 @@
 		this.canTriggerWalking = false;
 	}
 
+	protected void entityInit() {
+	}
+
 	public AxisAlignedBB getCollisionBox(Entity var1) {
 		return var1.boundingBox;
 	}
@@ -62,6 +68,9 @@
 	}
 
 	public boolean attackEntityFrom(Entity var1, int var2) {
+		if (this.worldObj.multiplayerWorld || this.isDead)
+			return true;
+		
 		this.forwardDirection = -this.forwardDirection;
 		this.timeSinceHit = 10;
 		this.damageTaken += var2 * 10;
@@ -78,6 +87,12 @@
 
 		return true;
 	}
+	
+	public void performHurtAnimation() {
+		this.forwardDirection = -this.forwardDirection;
+		this.timeSinceHit = 10;
+		this.damageTaken += 10;
+	}
 
 	public boolean canBeCollidedWith() {
 		return !this.isDead;
@@ -98,12 +113,15 @@
 					}
 
 					var2.stackSize -= var6;
-					EntityItem var7 = new EntityItem(this.worldObj, this.posX + (double)var3, this.posY + (double)var4, this.posZ + (double)var5, new ItemStack(var2.itemID, var6, var2.itemDmg));
-					float var8 = 0.05F;
-					var7.motionX = (double)((float)this.rand.nextGaussian() * var8);
-					var7.motionY = (double)((float)this.rand.nextGaussian() * var8 + 0.2F);
-					var7.motionZ = (double)((float)this.rand.nextGaussian() * var8);
-					this.worldObj.spawnEntityInWorld(var7);
+					if (!this.worldObj.multiplayerWorld) {
+						EntityItem var7 = new EntityItem(this.worldObj, this.posX + (double)var3, this.posY + (double)var4, this.posZ + (double)var5, new ItemStack(var2.itemID, var6, var2.getItemDamage()));
+						float var8 = 0.05F;
+						var7.motionX = (double)((float)this.rand.nextGaussian() * var8);
+						var7.motionY = (double)((float)this.rand.nextGaussian() * var8 + 0.2F);
+						var7.motionZ = (double)((float)this.rand.nextGaussian() * var8);
+						this.worldObj.spawnEntityInWorld(var7);
+					}
+					
 				}
 			}
 		}
@@ -113,6 +131,14 @@
 
 	public void onUpdate() {
 		double var7;
+		if(this.timeSinceHit > 0) {
+			--this.timeSinceHit;
+		}
+
+		if(this.damageTaken > 0) {
+			--this.damageTaken;
+		}
+		
 		if(this.worldObj.multiplayerWorld) {
 			if(this.turnProgress > 0) {
 				double var41 = this.posX + (this.minecartX - this.posX) / (double)this.turnProgress;
@@ -137,13 +163,6 @@
 			}
 
 		} else {
-			if(this.timeSinceHit > 0) {
-				--this.timeSinceHit;
-			}
-
-			if(this.damageTaken > 0) {
-				--this.damageTaken;
-			}
 
 			this.prevPosX = this.posX;
 			this.prevPosY = this.posY;
@@ -536,6 +555,9 @@
 	}
 
 	public void applyEntityCollision(Entity var1) {
+		if (this.worldObj.multiplayerWorld)
+			return;
+		
 		if(var1 != this.riddenByEntity) {
 			if(var1 instanceof EntityLiving && !(var1 instanceof EntityPlayer) && this.minecartType == 0 && this.motionX * this.motionX + this.motionZ * this.motionZ > 0.01D && this.riddenByEntity == null && var1.ridingEntity == null) {
 				var1.mountEntity(this);
@@ -643,6 +665,9 @@
 	}
 
 	public boolean interact(EntityPlayer var1) {
+		if (this.worldObj.multiplayerWorld)
+			return true;
+		
 		if(this.minecartType == 0) {
 			var1.mountEntity(this);
 		} else if(this.minecartType == 1) {
@@ -664,12 +689,27 @@
 		return true;
 	}
 
+	@Override
 	public void setPositionAndRotation(double var1, double var3, double var5, float var7, float var8, int var9) {
 		this.minecartX = var1;
 		this.minecartY = var3;
 		this.minecartZ = var5;
 		this.minecartYaw = (double)var7;
 		this.minecartPitch = (double)var8;
-		this.turnProgress = var9;
+		this.turnProgress = var9 + 2; // TODO: +2?
+		this.motionX = this.lerpVelocityX;
+		this.motionY = this.lerpVelocityY;
+		this.motionZ = this.lerpVelocityZ;
+	}
+
+	@Override
+	public void setVelocity(double velocityX, double velocityY, double velocityZ) {
+		this.lerpVelocityX = this.motionX = velocityX;
+		this.lerpVelocityY = this.motionY = velocityY;
+		this.lerpVelocityZ = this.motionZ = velocityZ;
+	}
+	
+	public boolean canInteractWith(EntityPlayer var1) {
+		return this.isDead ? false : var1.getDistanceSqToEntity(this) <= 64.0D;
 	}
 }
--- net/minecraft/src/EntitySlimeFX.java
+++ net/minecraft/src/EntitySlimeFX.java
@@ -3,7 +3,7 @@
 public class EntitySlimeFX extends EntityFX {
 	public EntitySlimeFX(World var1, double var2, double var4, double var6, Item var8) {
 		super(var1, var2, var4, var6, 0.0D, 0.0D, 0.0D);
-		this.particleTextureIndex = var8.getIconIndex((ItemStack)null);
+		this.particleTextureIndex = var8.getSprite(0);
 		this.particleRed = this.particleGreen = this.particleBlue = 1.0F;
 		this.particleGravity = Block.blockSnow.blockParticleGravity;
 		this.particleScale /= 2.0F;
--- net/minecraft/src/EntityPainting.java
+++ net/minecraft/src/EntityPainting.java
@@ -6,9 +6,9 @@
 public class EntityPainting extends Entity {
 	private int tickCounter;
 	public int direction;
-	private int xPosition;
-	private int yPosition;
-	private int zPosition;
+	public int xPosition;
+	public int yPosition;
+	public int zPosition;
 	public EnumArt art;
 
 	public EntityPainting(World var1) {
@@ -43,6 +43,28 @@
 
 		this.setDirection(var5);
 	}
+	
+	public EntityPainting(World var1, int var2, int var3, int var4, int var5, String var6) {
+		this(var1);
+		this.xPosition = var2;
+		this.yPosition = var3;
+		this.zPosition = var4;
+		EnumArt[] var7 = EnumArt.values();
+		int var8 = var7.length;
+
+		for(int var9 = 0; var9 < var8; ++var9) {
+			EnumArt var10 = var7[var9];
+			if(var10.title.equals(var6)) {
+				this.art = var10;
+				break;
+			}
+		}
+
+		this.setDirection(var5);
+	}
+	
+	protected void entityInit() {
+	}
 
 	public void setDirection(int var1) {
 		this.direction = var1;
@@ -106,7 +128,7 @@
 	}
 
 	public void onUpdate() {
-		if(this.tickCounter++ == 100 && !this.onValidSurface()) {
+		if(this.tickCounter++ == 100 && !this.onValidSurface() && !this.worldObj.multiplayerWorld) {
 			this.tickCounter = 0;
 			this.setEntityDead();
 			this.worldObj.spawnEntityInWorld(new EntityItem(this.worldObj, this.posX, this.posY, this.posZ, new ItemStack(Item.painting)));
@@ -174,6 +196,9 @@
 	}
 
 	public boolean attackEntityFrom(Entity var1, int var2) {
+		if (this.worldObj.multiplayerWorld)
+			return true;
+		
 		this.setEntityDead();
 		this.worldObj.spawnEntityInWorld(new EntityItem(this.worldObj, this.posX, this.posY, this.posZ, new ItemStack(Item.painting)));
 		return true;
--- /dev/null
+++ net/minecraft/src/ContainerFurnace.java
@@ -1,0 +1,101 @@
+package net.minecraft.src;
+
+public class ContainerFurnace extends Container {
+	private TileEntityFurnace furnace;
+	private int cookTime = 0;
+	private int burnTime = 0;
+	private int itemBurnTime = 0;
+
+	public ContainerFurnace(InventoryPlayer var1, TileEntityFurnace var2) {
+		this.furnace = var2;
+		this.addSlot(new Slot(var2, 0, 56, 17));
+		this.addSlot(new Slot(var2, 1, 56, 53));
+		this.addSlot(new SlotFurnace(var1.player, var2, 2, 116, 35));
+
+		int var3;
+		for(var3 = 0; var3 < 3; ++var3) {
+			for(int var4 = 0; var4 < 9; ++var4) {
+				this.addSlot(new Slot(var1, var4 + var3 * 9 + 9, 8 + var4 * 18, 84 + var3 * 18));
+			}
+		}
+
+		for(var3 = 0; var3 < 9; ++var3) {
+			this.addSlot(new Slot(var1, var3, 8 + var3 * 18, 142));
+		}
+
+	}
+
+	public void updateCraftingResults() {
+		super.updateCraftingResults();
+
+		for(int var1 = 0; var1 < this.field_20121_g.size(); ++var1) {
+			ICrafting var2 = (ICrafting)this.field_20121_g.get(var1);
+			if(this.cookTime != this.furnace.furnaceCookTime) {
+				var2.func_20158_a(this, 0, this.furnace.furnaceCookTime);
+			}
+
+			if(this.burnTime != this.furnace.furnaceBurnTime) {
+				var2.func_20158_a(this, 1, this.furnace.furnaceBurnTime);
+			}
+
+			if(this.itemBurnTime != this.furnace.currentItemBurnTime) {
+				var2.func_20158_a(this, 2, this.furnace.currentItemBurnTime);
+			}
+		}
+
+		this.cookTime = this.furnace.furnaceCookTime;
+		this.burnTime = this.furnace.furnaceBurnTime;
+		this.itemBurnTime = this.furnace.currentItemBurnTime;
+	}
+
+	public void func_20112_a(int var1, int var2) {
+		if(var1 == 0) {
+			this.furnace.furnaceCookTime = var2;
+		}
+
+		if(var1 == 1) {
+			this.furnace.furnaceBurnTime = var2;
+		}
+
+		if(var1 == 2) {
+			this.furnace.currentItemBurnTime = var2;
+		}
+
+	}
+
+	public boolean isUsableByPlayer(EntityPlayer var1) {
+		return this.furnace.canInteractWith(var1);
+	}
+
+	public ItemStack getStackInSlot(int var1) {
+		ItemStack var2 = null;
+		Slot var3 = (Slot)this.slots.get(var1);
+		if(var3 != null && var3.getHasStack()) {
+			ItemStack var4 = var3.getStack();
+			var2 = var4.copy();
+			if(var1 == 2) {
+				this.func_28125_a(var4, 3, 39, true);
+			} else if(var1 >= 3 && var1 < 30) {
+				this.func_28125_a(var4, 30, 39, false);
+			} else if(var1 >= 30 && var1 < 39) {
+				this.func_28125_a(var4, 3, 30, false);
+			} else {
+				this.func_28125_a(var4, 3, 39, false);
+			}
+
+			if(var4.stackSize == 0) {
+				var3.putStack((ItemStack)null);
+			} else {
+				var3.onSlotChanged();
+			}
+
+			if(var4.stackSize == var2.stackSize) {
+				return null;
+			}
+
+			var3.onPickupFromSlot(var4);
+		}
+
+		return var2;
+	}
+}
--- /dev/null
+++ net/minecraft/src/Packet19EntityAction.java
@@ -1,0 +1,36 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class Packet19EntityAction extends Packet {
+	public int entityId;
+	public int state;
+
+	public Packet19EntityAction() {
+	}
+
+	public Packet19EntityAction(Entity var1, int var2) {
+		this.entityId = var1.entityID;
+		this.state = var2;
+	}
+
+	public void readPacketData(DataInputStream var1) throws IOException {
+		this.entityId = var1.readInt();
+		this.state = var1.readByte();
+	}
+
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		var1.writeInt(this.entityId);
+		var1.writeByte(this.state);
+	}
+
+	public void processPacket(NetHandler var1) {
+		var1.func_21147_a(this);
+	}
+
+	public int getPacketSize() {
+		return 5;
+	}
+}
--- net/minecraft/src/GameSettings.java
+++ net/minecraft/src/GameSettings.java
@@ -36,6 +36,8 @@
 	public int numberOfOptions = 10;
 	public int difficulty = 2;
 	public boolean thirdPersonView = false;
+	
+	public boolean accept62 = true;
 
 	public GameSettings(Minecraft var1, File var2) {
 		this.mc = var1;
--- net/minecraft/src/BlockCrops.java
+++ net/minecraft/src/BlockCrops.java
@@ -100,7 +100,6 @@
 	}
 
 	public int idDropped(int var1, Random var2) {
-		System.out.println("Get resource: " + var1);
 		return var1 == 7 ? Item.wheat.shiftedIndex : -1;
 	}
 
